"""
A module with a HARD recursive function.

This function is the absolute hardest recursion question I have ever asked on a exam.
It was actually a mistake.  We did not adequately beta test the exam ahead of time
and did not realize how hard this problem was.

Author: Walker M. White
Data: October 12, 2020
"""


def segregate(nlist):
    """
    Returns a tuple segregating nlist into negative and non-negative.
    
    This function returns a tuple (pos,rlist). The value rlist is a reordered 
    copy of nlist where negatives come before the non-negatives. However, ordering 
    inside each part (negative, non-negatives) should remain EXACTLY as it is in nlist.
    The value pos indicates the first position of a non-negative number in rlist.

    If there are no non-negative numbers, pos is -1.

    Examples: 
        segregate([1, -1, 2, -5, -3, 0]) returns (3, [-1, -5, -3, 1, 2, 0]) 
        segregate([-1, -5, -3]) returns (-1, [-1, -5, -3])
        segregate([1, 5, 3]) returns (0, [1, 5, 3])
    
    Parameter nlist: The list to segregate
    Precondition: nlist is a (possibly empty) list of numbers
    """
    if nlist == []:
         return (-1,[])
    
    # Only need to recurse on right
    left = nlist[0]
    rght = segregate(nlist[1:])
    
    # UNPACK the right
    pos = rght[0] 
    rlist = rght[1]
    
    if left < 0:
        if pos >= 0:
            # The first nonnegative is the one in right
            npos = pos+1 
        else:
            npos = -1 
        return (npos,[left]+rlist)
    else:
        # Find where to insert left
        if pos >= 0:
            npos = pos
        else:
            # Left is the ONLY non-negative
            npos = len(rlist)
        
        nlist = rlist[:npos]+[left]+rlist[npos:]
        return (npos,nlist)
